<?php


/**
 * ==============================================
 * Rey Theme and Rey Core Plugin Support
 * ==============================================
 */
if ( class_exists('ReyCore') && PVTFW_COMMON::pvtfw_get_options()->cart_redirect == '' ):
    if( !function_exists('reycore_support') ):
        function reycore_support(){
            return false;
        }
        add_filter( 'pvtfw_added_cart_filter', 'reycore_support' );
    endif;
endif;


/**
 * ==============================================
 * Divi Theme Support
 * ==============================================
 */

if( !function_exists( 'pvtfw_divi_mini_cart_fragment' ) ):

    function pvtfw_divi_mini_cart_fragment( $fragments ) {

        $theme = wp_get_theme();

        if( WC()->cart->get_cart_contents_count() == 1 ){
            $item_text = __( 'Item', 'product-variant-table-for-woocommerce' );
        }
        else{
            $item_text = __( 'Items', 'product-variant-table-for-woocommerce' );
        }

        if ( 'Divi' == $theme->name || 'Divi' == $theme->parent_theme ) {
            $fragments['.et-cart-info span'] = "<span>" . WC()->cart->get_cart_contents_count() . " $item_text</span>";
            return $fragments; 
        }

        return $fragments;
    }
    add_filter( 'woocommerce_add_to_cart_fragments', 'pvtfw_divi_mini_cart_fragment', 10, 1 ); 

endif;


/**
 * =============================================================================
 * Whols plugin by Woolentor support 
 * =============================================================================
 */


if ( !function_exists( 'pvt_whols_plugin_support' ) && PVTFW_COMMON::check_plugin_state('whols') ){

    

    function pvt_whols_plugin_support( $price_html, $single_variation ){

        $whols_plugin_options = (array) get_option( 'whols_options' );

        if( $whols_plugin_options['price_type_1_properties']['enable_this_pricing'] == 0  ){
            return $single_variation->get_price_html();
        }

        $wholesale_status    = whols_is_on_wholesale( $single_variation );
        $enable_this_pricing = $wholesale_status['enable_this_pricing'];
        $price_type          = $wholesale_status['price_type'];
        $price_value         = $wholesale_status['price_value'];
        $minimum_quantity    = $wholesale_status['minimum_quantity'];

        if( $enable_this_pricing ){
            if($price_type == 'flat_rate'){
                $price_per_unit = $price_value;
            } elseif($price_type == 'percent'){
                $price_per_unit = whols_get_percent_of( $single_variation->get_regular_price(), $price_value );
            }

            $whols_price = '<span class="price">' .  wc_price( $price_per_unit ) . '</span>';
        }
        
        return $whols_price;

    }
    add_filter( 'pvtfw_price_html', 'pvt_whols_plugin_support', 20, 2 );

}


/**
 * =============================================================================
 * Applying `get_price_html` by adding filter for backward compatibility
 * =============================================================================
 */


if ( !function_exists( 'pvt_get_price_html' ) ){

    function pvt_get_price_html( $price_html, $single_variation ){
        
        return $single_variation->get_price_html()."<input type='hidden' name='hidden_price' class='hidden_price' value='".$single_variation->get_price()."'>";

    }
    add_filter( 'pvtfw_price_html', 'pvt_get_price_html', 10, 2 );

}
