<?php

if( !class_exists('PVTFW_AVAILABE_BTN' )):

    class PVTFW_AVAILABE_BTN {

        protected static $_instance = null;

        public function __construct(){
            $this->register();
        }


        public static function instance() {
            if( is_null( self::$_instance ) ) {
                self::$_instance = new self();
            }

            return self::$_instance;
        }

        /**
        *====================================================
        * Available option button block
        *====================================================
        **/
        function available_options_btn()
        {
            global $product;
            if (!$product->is_type('variable')) {
                return;
            }?>
        <div class="available-options-btn">

            <?php
                //Getting Available Button Text
                $available_btn_text =  PVTFW_COMMON::pvtfw_get_options()->available_btn_text;
                if(!$available_btn_text){
                    $available_text = __('Available options', 'product-variant-table-for-woocommerce');
                } 
                else{
                    $available_text = $available_btn_text;
                }

            ?>
            <button scrollto="#variant-table" type="button"
                class="available-options-btn single_add_to_cart_button button alt"><?php echo $available_text; ?></button>
        </div>
        <?php
        }

        /**
        *====================================================
        * Register
        *====================================================
        **/

        function register() {
            $showAvailableOptionBtn = PVTFW_COMMON::pvtfw_get_options()->showAvailableOptionBtn;
            if ($showAvailableOptionBtn == 'on') {
                add_action('woocommerce_single_product_summary', array($this, 'available_options_btn'), 11);
            }
        }
        
    }

    $pvtfw_available_btn = PVTFW_AVAILABE_BTN::instance();

endif;